#
# spec file for package openssl (Version 0.9.6c)
#
# Copyright (c) 2004 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  -ssleay
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext libtool libz pam perl rpm

Name:         openssl
%define num_version %(echo "%{version}" | sed -e "s+[a-zA-Z]++g")
License:      BSD, Other License(s), see package
Group:        Productivity/Networking/Security
Provides:     ssl
Conflicts:    ssleay
Obsoletes:    ssleay
Autoreqprov:  on
Version:      0.9.6c
Release:      88
Summary:      Secure Sockets and Transport Layer Security
URL:          http://www.openssl.org/
Source:       http://www.%{name}.org/source/%{name}-engine-%{version}.tar.bz2
Source10:     README.SuSE
Patch0:       %{name}-0.9.6c.dif
Patch1:       %{name}-0.9.6c-mips.dif
Patch2:       %{name}-0.9.6b-arm.dif
Patch3:       openssl-nocrypt.diff
# http://www-124.ibm.com/developerworks/projects/libica/
Patch10:      ibmca.patch-096c-20020129.gz
Patch11:      openssl-engine-0.9.6c-security.patch
Patch12:      openssl-0.9.6c.CBC-timing-attack.dif
Patch13:      openssl-timing-attacks.patch
Patch15:      openssl-engine-0.9.6d-asn1.dif
Patch16:      openssl-CAN-2004-0079.dif
Patch17:      openssl-0.9.6c-CAN-2004-0081.dif
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, full-featured, and Open Source toolkit implementing
the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS
v1) protocols with full-strength cryptography world-wide. The project
is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL toolkit and its
related documentation.


Derivation and License


OpenSSL is based on the excellent SSLeay library developed from Eric
A. Young and Tim J. Hudson. The OpenSSL toolkit is licensed under a
Apache-style licence which basically means that you are free to get
and use it for commercial and non-commercial purposes.

Authors:
--------
    Mark J. Cox <mark@openssl.org>
    Ralf S. Engelschall <rse@openssl.org>
    Dr. Stephen Henson <steve@openssl.org>
    Ben Laurie <ben@openssl.org>
    Bodo Moeller <bodo@openssl.org>
    Ulf Moeller <ulf@openssl.org>
    Holger Reif <holger@openssl.org>
    Paul C. Sutton <paul@openssl.org>

SuSE series: sec

%package devel
Summary:      The OpenSSL source tree
Group:        Development/Libraries/C and C++
Obsoletes:    openssls

%description devel
This package containes the OpenSSL source tree, header files and
static libraries.

Authors:
--------
    Mark J. Cox <mark@openssl.org>
    Ralf S. Engelschall <rse@openssl.org>
    Dr. Stephen <Henson steve@openssl.org>
    Ben Laurie <ben@openssl.org>
    Bodo Moeller <bodo@openssl.org>
    Ulf Moeller <ulf@openssl.org>
    Holger Reif <holger@openssl.org>
    Paul C. Sutton <paul@openssl.org>

SuSE series: d

%package doc
Summary:      documentation and examples for OpenSSL
Group:        Productivity/Networking/Security

%description doc
This package contains the documentation and examples for OpenSSL.

Authors:
--------
    Mark J. Cox <mark@openssl.org>
    Ralf S. Engelschall <rse@openssl.org>
    Dr. Stephen <Henson steve@openssl.org>
    Ben Laurie <ben@openssl.org>
    Bodo Moeller <bodo@openssl.org>
    Ulf Moeller <ulf@openssl.org>
    Holger Reif <holger@openssl.org>
    Paul C. Sutton <paul@openssl.org>

SuSE series: doc

%prep
%setup -n %{name}-engine-%{version}
%patch -p1
%patch1 -p1
%patch2
%patch3
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
cp -p %{S:10} .

%build
# change /usr/lib to /usr/lib64 if necessary
sed "s+\(\$(INSTALL_PREFIX)\$(INSTALLTOP)\)/lib+\1/%_lib+" Makefile.org > Makefile.new \
	&& diff -u Makefile.org Makefile.new \
	|| mv Makefile.new Makefile.org
./config threads shared no-rc5 no-idea 		\
	--prefix=%{_prefix} 			\
	--openssldir=%{_datadir}/ssl 		\
	$RPM_OPT_FLAGS -fPIC 
make TABLE
# show settings
echo $RPM_OPT_FLAGS
eval $(egrep PLATFORM='[[:alnum:]]' Makefile)
grep -B1 -A21 "^\*\*\* $PLATFORM$" TABLE 
make
LD_LIBRARY_PATH=`pwd` make rehash
%ifnarch armv4l
LD_LIBRARY_PATH=`pwd` make test
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
make MANDIR=%{_mandir} INSTALL_PREFIX=$RPM_BUILD_ROOT install
install -m755 libRSAglue.a $RPM_BUILD_ROOT/%{_libdir}
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}
cp -pr certs/* $RPM_BUILD_ROOT/%{_datadir}/ssl/certs
ln -sf ./%{name} $RPM_BUILD_ROOT/%{_includedir}/ssl
# work around file conflicts
mv $RPM_BUILD_ROOT/%{_mandir}/man1/passwd.1 $RPM_BUILD_ROOT/%{_mandir}/man1/sslpasswd.1
mv $RPM_BUILD_ROOT/%{_mandir}/man3/rand.3   $RPM_BUILD_ROOT/%{_mandir}/man3/sslrand.3
#
# check wether some shared library has been installed
#
ls -l $RPM_BUILD_ROOT/%{_libdir}
test -f $RPM_BUILD_ROOT/%{_libdir}/libssl.so.%{num_version} || exit 1
test -L $RPM_BUILD_ROOT/%{_libdir}/libssl.so.0              || exit 2
test -L $RPM_BUILD_ROOT/%{_libdir}/libssl.so                || exit 3
#
# see what we've got
#
cat > showciphers.c <<EOF
#include <openssl/err.h>
#include <openssl/ssl.h>
main(){
unsigned int i;
SSL_CTX *ctx;
SSL *ssl;
SSL_METHOD *meth;
  meth = SSLv2_client_method();
  SSLeay_add_ssl_algorithms();
  ctx = SSL_CTX_new(meth);
  if (ctx == NULL) return 0;
  ssl = SSL_new(ctx);
  if (!ssl) return 0;
  for (i=0; ; i++) {
    int j, k;
    SSL_CIPHER *sc;
    sc = (meth->get_cipher)(i);
    if (!sc) break;
    k = SSL_CIPHER_get_bits(sc, &j);
    printf("%s\n", sc->name);
  }
};
EOF
gcc $RPM_OPT_FLAGS -I${RPM_BUILD_ROOT}%{_includedir} -c showciphers.c
gcc -o showciphers showciphers.o -L${RPM_BUILD_ROOT}%{_libdir} -lssl -lcrypto
LD_LIBRARY_PATH=${RPM_BUILD_ROOT}%{_libdir} ./showciphers > AVAILABLE_CIPHERS
cat AVAILABLE_CIPHERS
#%clean
#make clean
#[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files devel
%defattr(-, root, root)
%{_includedir}/%{name}/
%{_includedir}/ssl
%{_libdir}/libcrypto.a
%{_libdir}/libssl.a
%{_libdir}/libRSAglue.a
%{_libdir}/libcrypto.so
%{_libdir}/libssl.so

%files doc
%defattr(-, root, root)
%doc doc/* demos
%doc showciphers showciphers.c 
%doc %{_mandir}/man*/*

%files
%defattr(-, root, root)
%doc CHANGE* INSTAL* AVAILABLE_CIPHERS
%doc LICENSE NEWS README README.SuSE openssl.doxy
%doc %{_mandir}/man1/openssl.1.gz
%{_datadir}/ssl
%{_bindir}/c_rehash
%{_bindir}/%{name}
%{_libdir}/libssl.so.0
%{_libdir}/libssl.so.%{num_version}
%{_libdir}/libcrypto.so.0
%{_libdir}/libcrypto.so.%{num_version}

%changelog -n openssl
* Tue Mar 23 2004 - poeml@suse.de
- fix possible DoS attack CAN-2004-0081 [#36657]
  (Fix ssl3_read_bytes (ssl/s3_pkt.c): To ignore messages of unknown
  type, we must throw them away by setting rr->length to 0.)
* Tue Mar 02 2004 - poeml@suse.de
- add security fix for CAN-2004-0079 (possible null-pointer
  assignment during SSL/TLS handshake)
* Tue Sep 30 2003 - poeml@suse.de
- security fix (CAN-2003-0543, CAN-2003-0544): fix vulnerabilities
  in ASN.1 parsing, and an error in the SSL/TLS protocol handling
* Tue Mar 25 2003 - krahmer@suse.de
- security fix for two different kind of attacks against the
  RSA implementation: timing and an extention of the "Bleichenbacher
  attack"
* Thu Feb 20 2003 - poeml@suse.de
- security fix: In ssl3_get_record (ssl/s3_pkt.c), minimize
  information leaked via timing by performing a MAC computation
  even if incorrrect block cipher padding has been found.  This
  is a countermeasure against active attacks where the attacker
  has to distinguish between bad padding and a MAC verification
  error.  (CAN-2003-0078)
* Tue Aug 06 2002 - draht@suse.de
- correction to the ASN1 part of the last iteration of the
  security patch from the OpenSSL team
* Mon Jul 29 2002 - okir@suse.de
- Another iteration of the security patch from the OpenSSL team
* Fri Jul 26 2002 - okir@suse.de
- Added security patch for remotely exploitable buffer overflows
* Wed Feb 06 2002 - kukuk@suse.de
- Remove crypt function from libcrypto.so.0 [Bug #13056]
* Sun Feb 03 2002 - poeml@suse.de
- add settings for mips to build shared objects
- print out all settings to the build log
* Tue Jan 29 2002 - poeml@suse.de
- update to 0.9.6c:
  o bug fixes
  o support for hardware crypto devices (Cryptographic Appliances,
  Broadcom, and Accelerated Encryption Processing)
- add IBMCA patch for IBM eServer Cryptographic Accelerator Device
  Driver (#12565) (forward ported from 0.9.6b)
  (http://www-124.ibm.com/developerworks/projects/libica/)
- tell Configure how to build shared libs for s390 and s390x
- tweak Makefile.org to use %%_libdir
- clean up spec file
- add README.SuSE as source file instead of in a patch
* Wed Dec 05 2001 - uli@suse.de
- disabled "make test" for ARM (destest segfaults, the other tests
  seem to succeed)
* Wed Dec 05 2001 - ro@suse.de
- removed subpackage src
* Wed Nov 28 2001 - uli@suse.de
- needs -ldl on ARM, too
* Mon Nov 19 2001 - mls@suse.de
- made mips big endian, fixed shared library creation for mips
* Fri Aug 31 2001 - rolf@suse.de
- added root certificates [BUG#9913]
- move from /usr/ssh to /usr/share/ssl
* Wed Jul 18 2001 - rolf@suse.de
- update to 0.9.6b
- switch to engine version of openssl, which supports hardware
  encryption for a few popular devices
- check wether shared libraries have been generated
* Thu Jul 05 2001 - rolf@suse.de
- appliy PRNG security patch
* Tue Jun 12 2001 - bk@suse.de
- added support for s390x
* Mon May 07 2001 - kukuk@suse.de
- Fix building of shared libraries on SPARC, too.
* Mon May 07 2001 - rolf@suse.de
- Fix ppc and s390 shared library builds
- resolved conflict in manpage naming:
  rand.3 is now sslrand.3 [BUG#7643]
* Tue May 01 2001 - schwab@suse.de
- Fix ia64 configuration.
- Fix link command.
* Thu Apr 26 2001 - bjacke@suse.de
- updated to 0.96a
* Wed Apr 18 2001 - kkaempf@suse.de
- provide .so files in -devel package only
* Tue Apr 17 2001 - bjacke@suse.de
- resolve file name conflict (#6966)
* Wed Mar 21 2001 - rolf@suse.de
- new subpackage openssl-src [BUG#6383]
- added README.SuSE which explains where to find the man pages [BUG#6717]
* Fri Dec 15 2000 - sf@suse.de
- changed CFLAG to -O1 to make the tests run successfully
* Mon Dec 11 2000 - rolf@suse.de
- build openssl with no-idea and no-rc5 to meet US & RSA regulations
- build with -fPIC on all platforms (especially IA64)
* Wed Nov 22 2000 - rolf@suse.de
- rename openssls to openssl-devel and add shared libs and header files
- new subpackge openssl-doc for manpages and documentation
- use BuildRoot
* Fri Oct 27 2000 - schwab@suse.de
- Add link-time links for libcrypto and libssl.
- Make sure that LD_LIBRARY_PATH is passed down to sub-makes.
* Mon Oct 02 2000 - rolf@suse.de
- update to 0.9.6
* Mon Apr 10 2000 - bk@suse.de
- fix support for s390-linux
* Mon Apr 10 2000 - rolf@suse.de
- new version 0.9.5a
* Sun Apr 09 2000 - bk@suse.de
- add support for s390-linux
* Mon Mar 27 2000 - kukuk@suse.de
- Use sparcv7 for SPARC
* Wed Mar 01 2000 - rolf@suse.de
- move manpages back, as too many conflict with system manuals
* Wed Mar 01 2000 - rolf@suse.de
- move manpages to %%{_mandir}
- include static libraries
* Wed Mar 01 2000 - bk@suse.de
- added subpackage source openssls, needed for ppp_ssl
* Tue Feb 29 2000 - rolf@suse.de
- new version 0.9.5
* Thu Feb 24 2000 - schwab@suse.de
- add support for ia64-linux
* Mon Jan 31 2000 - kukuk@suse.de
- Create and add libcrypto.so.0 and libssl.so.0
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Sep 01 1999 - rolf@suse.de
- new version 0.9.4
* Wed May 26 1999 - rolf@suse.de
- new version 0.9.3 with new layout
- alpha asm disabled by default now, no patch needed
* Thu May 20 1999 - ro@suse.de
- disable asm for alpha: seems incomplete
* Mon May 17 1999 - rolf@suse.de
- don't use -DNO_IDEA
* Wed May 12 1999 - rolf@suse.de
- first version 0.9.2b
